/*

@C:\WIN_V1.53\SQL\ORACLE\1045_RECSTP_GRAVA_CONTA_COMISSAO.SQL;

P_GERA_ERRO = 0 -> COMANDO EXECUTADO
P_GERA_ERRO = 1 -> TIPO DE CONTA DEVE SER INFORMADA
P_GERA_ERRO = 2 -> CLASSIFICACAO FINANCEIRA DEVE SER INFORMADA
P_GERA_ERRO = 3 -> SERIE DEVE SER INFORMADA
P_GERA_ERRO = 4 -> CONTA ATUALIZADA COM SUCESSO

Debugar:
   raise_application_error(-20501, '', True);

*/

CREATE OR REPLACE PROCEDURE GRAVA_CONTA_COMISSAO
   (P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
    P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
    P_VRCONTAPAG   IN CONTAPAGAR.VRORIGPAG%TYPE,
    P_DTCONTAPAG   IN CONTAPAGAR.DTORIGVENPAG%TYPE,
    P_CDFORNECED   IN FORNECEDOR.CDFORNECED%TYPE,
    P_NRNOTAFISC   IN NOTAFISCAL.NRNOTAFISC%TYPE,
    P_NRLANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_NRLANBOLPAG  IN BOLETPAGAR.NRLANBOLPAG%TYPE,
    P_CDFILIRECE   IN NOTAFISCAL.CDFILIRECE%TYPE,
    P_CDVENDEDOR   IN NOTAFISCAL.CDVENDEDOR%TYPE,
    P_DSCONTAPAG   IN CONTAPAGAR.DSCONTAPAG%TYPE,
    P_NRPARCPGTOFO IN FORNECEDOR.NRPARCPGTOFO%TYPE,
    P_VRCONTAPARC  IN CONTAPAGAR.VRORIGPAG%TYPE,
    P_CDSERIE      IN NOTAFISCAL.CDSERIE%TYPE,
    P_NRSEQVENPAG  IN CONTAPAGAR.NRSEQVENPAG%TYPE,
    P_GERA_ERRO   OUT VARCHAR2,
    P_CDTPCTPAGAR OUT TIPOCTPAGAR.CDTPCTPAGAR%TYPE)  
AS
   V_CDINSCESTA   NOTAFISCAL.CDINSCESTA%TYPE;
   V_CDINSCMUNI   NOTAFISCAL.CDINSCMUNI%TYPE;
   V_IDTPIJURNF   FORNECEDOR.IDTPIJURFORN%TYPE;
   V_NRINSJURNF   FORNECEDOR.NRINSJURFORN%TYPE;
   V_IDTPFORPGTFO FORNECEDOR.IDTPFORPGTFO%TYPE;
   V_IDFORMAPGTO  FORNECEDOR.IDTPFORPGTFO%TYPE;
   V_IDUTDIAPGTO  FORNECEDOR.IDUTDIAPGTFO%TYPE;
   V_NRDIAPGFIXO  FORNECEDOR.NRDIAPGFIXFO%TYPE;
   V_CDFORMPGTO   FORNECEDOR.CDFORMPGTO%TYPE;
   V_NRPARCPGTO   FORNECEDOR.NRPARCPGTOFO%TYPE;
   V_DSTPCTPAGAR  TIPOCTPAGAR.DSTPCTPAGAR%TYPE;
   V_CDCLASSFINA  TIPOCTPAGAR.CDCLASSFINA%TYPE;
   V_CDTPCTPAGAR  TIPOCTPAGAR.CDTPCTPAGAR%TYPE;
   V_CDSERIE      FILIAL.CDSERIE%TYPE;
   V_INNRPARC     CONTAPAGAR.NRPARCELAPAG%TYPE;
   V_PARCELA      CONTAPAGAR.NRPARCELAPAG%TYPE;   
   V_DTPARC       CONTAPAGAR.DTATUAVENPAG%TYPE;
   V_VRPARCVENC   CONTAPAGAR.VRORIGPAG%TYPE;
   V_DTVENCIMENTO CONTAPAGAR.DTORIGVENPAG%TYPE;
   V_IDTIPODTPGTO FORMPGTO.IDTIPODTPGTO%TYPE;
   V_IDTPPERIODO  FORMPGTO.IDTPPERIODO%TYPE;
   V_CTNOTA         NUMBER;
   V_INDIAS         NUMBER;
   V_INCOUNT        NUMBER;
   V_INGUARDANRDIAS NUMBER;
   V_NMRAZSOCFORN  FORNECEDOR.NMRAZSOCFORN%TYPE;
   V_NRSEQVENPAG   CONTAPAGAR.NRSEQVENPAG%TYPE;
   V_NRLANBOLPAG   VARCHAR2(20);
   V_PROXLANBOLPAG VARCHAR2(20);
   
BEGIN
   SELECT COUNT(*) INTO V_CTNOTA
   FROM NOTAFISCAL
   WHERE
      CDFILIAL   = P_CDFILIAL AND
      NRLANCTONF = P_NRLANCTONF;

   IF V_CTNOTA = 0 THEN
      SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
      INTO V_CDINSCESTA, V_CDINSCMUNI
      FROM EMPRCNTRFIL
      WHERE (CDFILIAL  = P_CDFILIRECE) AND
            (CDEMPRESA = P_CDEMPRESA);

      IF (V_CDINSCESTA IS NULL) OR (V_CDINSCMUNI IS NULL) THEN
         SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
         INTO V_CDINSCESTA, V_CDINSCMUNI
         FROM FILIAL
         WHERE (CDFILIAL  = P_CDFILIRECE) AND
               (CDEMPRESA = P_CDEMPRESA);
      END IF;

      SELECT MAX(IDTPIJURFORN), MAX(NRINSJURFORN), MAX(CDTPCTPAGAR), MAX(NMRAZSOCFORN)  
      INTO V_IDTPIJURNF, V_NRINSJURNF, V_CDTPCTPAGAR, V_NMRAZSOCFORN 
      FROM FORNECEDOR
      WHERE CDFORNECED = P_CDFORNECED;
      
      SELECT F.IDTPFORPGTFO , F.IDUTDIAPGTFO, F.NRDIAPGFIXFO,
             FP.IDTIPODTPGTO, F.CDFORMPGTO  , FP.IDTPPERIODO,
             F.NRPARCPGTOFO
        INTO V_IDFORMAPGTO , V_IDUTDIAPGTO, V_NRDIAPGFIXO, 
             V_IDTIPODTPGTO, V_CDFORMPGTO , V_IDTPPERIODO, 
             V_NRPARCPGTO
        FROM FORNECEDOR F, FORMPGTO FP
       WHERE (F.CDFORNECED = P_CDFORNECED)
         AND (F.CDFORMPGTO = FP.CDFORMPGTO(+));

      IF V_CDTPCTPAGAR IS NULL THEN
         SELECT MAX(CDTPCTPAGAR)
         INTO V_CDTPCTPAGAR
         FROM TIPOOPERAC
         WHERE CDTIPOOPER   = '12' AND
               IDENTRSAIDOP = 'E';
      END IF;

      IF NOT (V_CDTPCTPAGAR IS NULL) THEN
         SELECT MAX(DSTPCTPAGAR), MAX(CDCLASSFINA)
         INTO V_DSTPCTPAGAR, V_CDCLASSFINA
         FROM TIPOCTPAGAR
         WHERE CDTPCTPAGAR = V_CDTPCTPAGAR;
      END IF;

      P_GERA_ERRO   := '0';
      P_CDTPCTPAGAR := V_CDTPCTPAGAR;

      IF (V_CDTPCTPAGAR IS NULL) THEN
         P_GERA_ERRO := '1'||'@'||V_IDTPIJURNF||'@'||V_NRINSJURNF||'@'||V_NMRAZSOCFORN;
      END IF;

      IF(P_GERA_ERRO IS NULL) THEN
         IF (V_CDCLASSFINA IS NULL) THEN
            P_GERA_ERRO := '2'||'@'||V_CDTPCTPAGAR||' - '||V_DSTPCTPAGAR;
         END IF;
      END IF;

      IF P_GERA_ERRO = '0' THEN

         INSERT INTO NOTAFISCAL
            (CDFILIAL   , NRLANCTONF  , CDEMPRESA , CDINSCESTA , CDINSCMUNI ,
             IDTPIJURNF , NRINSJURNF  , CDFORNECED, IDBLOQUEADO, IDDOCFISCAL,
             IDDOCFINANC, NRNOTAFISC  , DTEMISSAO , DTENTRSAID , VRPRODUTOS ,
             VRNOTAFISC , IDENTRSAIDOP, CDTIPOOPER, IDDOCCONTAB, IDSTATUS   ,
             IDSISTEMA  , CDSERIEENTR , CDFILIRECE, CDVENDEDOR)
         VALUES
            (P_CDFILIAL  , P_NRLANCTONF, P_CDEMPRESA , V_CDINSCESTA, V_CDINSCMUNI,
             V_IDTPIJURNF, V_NRINSJURNF, P_CDFORNECED, 'S'         , 'N'         ,
             'S'         , P_NRNOTAFISC, P_DTCONTAPAG, P_DTCONTAPAG, P_VRCONTAPAG,
             P_VRCONTAPAG, 'E'         , '12'        , 'S'         , 'A'         ,
             'PAG'       , P_CDSERIE   , P_CDFILIRECE, P_CDVENDEDOR);  
         
/* ================================ SEM FORMA DE PAGAMENTO =========================================== */         
         IF ((V_IDFORMAPGTO IS NULL) OR ((V_IDFORMAPGTO <> 'F') AND (V_IDFORMAPGTO <> 'V'))) THEN
            --V_NRPARCELAS := 1;
      
            INSERT INTO BOLETPAGAR
               (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
            VALUES
               (P_CDFILIAL  , P_NRLANBOLPAG, P_CDFORNECED, P_CDEMPRESA,  P_VRCONTAPAG,
                P_VRCONTAPAG, P_DTCONTAPAG , 'N'         , 'A'        ,
                'N'         , '00'         , '00');              

            -- - ATUALIZA O FLUXO DE CAIXA -------------------------- --
            ATUALIZA_FLUXO_DE_CAIXA(P_CDEMPRESA,  P_CDFILIAL, P_DTCONTAPAG,
                                            'E', V_CDCLASSFINA, 0, P_VRCONTAPAG);

            IF ((P_NRSEQVENPAG IS NULL) OR (P_NRSEQVENPAG = '')) THEN
               V_NRSEQVENPAG := '00';
            ELSE
               V_NRSEQVENPAG := P_NRSEQVENPAG;
            END IF;   

            INSERT INTO CONTAPAGAR
               (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
            VALUES
               (P_CDFILIAL , P_NRLANCTONF, V_NRSEQVENPAG, '00'        , V_CDTPCTPAGAR,
                '0'        , P_DTCONTAPAG, P_VRCONTAPAG , P_DTCONTAPAG, P_VRCONTAPAG ,
                'A', P_DSCONTAPAG||' - '|| V_DSTPCTPAGAR, P_CDFILIAL  , P_NRLANBOLPAG, V_CDCLASSFINA,
                P_CDEMPRESA, P_CDFILIAL  , P_DTCONTAPAG , 'E');           
           
/* =============================== FORMA DE PAGAMENTO FIXA =========================================== */      
         ELSIF (V_IDFORMAPGTO = 'F') THEN
            
            V_INCOUNT       := 0;
            V_INNRPARC      := 01;
            V_DTPARC        := NULL;
            V_DTVENCIMENTO  := P_DTCONTAPAG;
            V_NRLANBOLPAG   := P_NRLANBOLPAG;
            V_VRPARCVENC    := 0;
            V_DTPARC        := P_DTCONTAPAG;
               
            IF NOT (V_NRPARCPGTO > 1) THEN
               V_NRPARCPGTO := 1;
               V_INNRPARC   := 0;
            END IF;
            V_VRPARCVENC    := P_VRCONTAPAG / V_NRPARCPGTO;
               
            IF NOT (V_DTVENCIMENTO IS NULL) THEN
               /* FORMA FIXA Verifica se o numero informado no cadastro de forma de pagamento  maior
               ou igual ao dia da data de vencimento. Ou se o opo de gerar 1 parcela no proximo mes
               esteja marcada  */
               IF (V_IDUTDIAPGTO = 'I') THEN
                  IF (V_NRDIAPGFIXO >= TO_NUMBER(TO_CHAR(V_DTVENCIMENTO, 'DD'))) THEN
                     /* pega o maior dia do mes */
                     V_INDIAS :=  TO_NUMBER(TO_CHAR(LAST_DAY(V_DTVENCIMENTO), 'DD'));
     
                     /* Verifica se numero informado no cadastro de forma de pagamento 
                         maior que o ultimo dia do mes. Exemplo informou 31 no cadastro e o ultimo dia do e 30*/
                     IF (V_NRDIAPGFIXO > V_INDIAS) THEN
                        /*Pega o maior dia do mes */
                        V_DTVENCIMENTO := LAST_DAY(V_DTVENCIMENTO);
                     ELSE
                               /*Joga a data com o dia informado na parametrizcao */
                        V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAPGFIXO)||'/'||TO_CHAR(V_DTVENCIMENTO, 'MM/YYYY'), 'DD/MM/YYYY');                   
                     END IF;
                  ELSE
                     V_DTVENCIMENTO := ADD_MONTHS(V_DTVENCIMENTO, 1);
                     V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAPGFIXO)||'/'||TO_CHAR(V_DTVENCIMENTO, 'MM/YYYY'), 'DD/MM/YYYY');
                  END IF;
               ELSE
                  V_DTVENCIMENTO := ADD_MONTHS(V_DTVENCIMENTO, 1);
                  V_DTVENCIMENTO := TO_DATE(TO_CHAR(V_NRDIAPGFIXO)||'/'||TO_CHAR(V_DTVENCIMENTO, 'MM/YYYY'), 'DD/MM/YYYY');
               END IF;
            END IF;   
                                 
            WHILE (V_INCOUNT <> V_NRPARCPGTO) LOOP
         
               V_PROXLANBOLPAG := NULL;
         
               IF ((P_NRSEQVENPAG IS NULL) OR (P_NRSEQVENPAG = '')) THEN
                  V_NRSEQVENPAG := '00';
               ELSE
                  V_NRSEQVENPAG := P_NRSEQVENPAG;
               END IF;   
      
               SELECT DISTINCT ADD_MONTHS(V_DTVENCIMENTO, V_INCOUNT) INTO V_DTVENCIMENTO
                 FROM CONTAPAGAR;   
                        
               INSERT INTO BOLETPAGAR
                  (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                   VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                   IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
               VALUES
                  (P_CDFILIAL  , V_NRLANBOLPAG , P_CDFORNECED, P_CDEMPRESA, V_VRPARCVENC,
                   V_VRPARCVENC, V_DTVENCIMENTO, 'N'         , 'A'        ,
                   'N'         , '00'          , '00');

               -- - ATUALIZA O FLUXO DE CAIXA -------------------------- --
               ATUALIZA_FLUXO_DE_CAIXA(P_CDEMPRESA,  P_CDFILIAL, V_DTVENCIMENTO,
                                               'E', V_CDCLASSFINA, 0, V_VRPARCVENC);                               

               INSERT INTO CONTAPAGAR
                  (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                   QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                   IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                   CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
               VALUES
                  (P_CDFILIAL , P_NRLANCTONF  , V_NRSEQVENPAG  , LPAD(V_INNRPARC, 2, 0), V_CDTPCTPAGAR,
                   '0'        , V_DTVENCIMENTO, V_VRPARCVENC   , V_DTVENCIMENTO , V_VRPARCVENC ,
                   'A', P_DSCONTAPAG||' - '|| V_DSTPCTPAGAR    , P_CDFILIAL     , V_NRLANBOLPAG, V_CDCLASSFINA,
                   P_CDEMPRESA, P_CDFILIAL    , V_DTVENCIMENTO , 'E');
             
               V_INCOUNT  := V_INCOUNT  + 1;
               V_INNRPARC := V_INNRPARC + 1;
               IF (V_NRPARCPGTO > 1) THEN
                  NOVO_CODIGO('BOLETPAGAR'||P_CDFILIAL, V_PROXLANBOLPAG, 1);
                  V_NRLANBOLPAG := SUBSTR(V_PROXLANBOLPAG, 11,10);   
               END IF;               
         
            END LOOP;

/* ============================= FORMA DE PAGAMENTO VARIVEL ========================================= */      
         ELSE 
            --V_SEQUENCIAL    := 1;
            --V_VRPARCAUXI    := 0;
            V_PARCELA       := 0;
            V_INCOUNT       := 0;            
            V_NRLANBOLPAG   := P_NRLANBOLPAG;   
            V_DTVENCIMENTO  := P_DTCONTAPAG; 
            V_DTPARC        := NULL;
               
            SELECT COUNT(*) 
              INTO V_INCOUNT                       
              FROM PRAZOPGTFORN
             WHERE (CDFORNECED = P_CDFORNECED); 
             
            IF (V_INCOUNT > 1) THEN
               V_PARCELA := 1;
            END IF;     
            
            IF NOT V_IDFORMAPGTO IS NULL THEN
               IF V_IDFORMAPGTO = 'V' THEN
                  IF V_IDTIPODTPGTO = 'EMIN' THEN
                     V_INDIAS := 0;
                     V_DTPARC := P_DTCONTAPAG;
                  ELSIF V_IDTIPODTPGTO = 'EMEX' THEN
                     V_INDIAS := 1;
                     V_DTPARC := P_DTCONTAPAG;
                  ELSIF V_IDTIPODTPGTO = 'ENIN' THEN
                     V_INDIAS := 0;
                     V_DTPARC := P_DTCONTAPAG;
                  ELSIF V_IDTIPODTPGTO = 'ENEX' THEN
                     V_INDIAS := 1;
                     V_DTPARC := P_DTCONTAPAG;
                  ELSIF V_IDTIPODTPGTO = 'UEMI' THEN
                     V_INDIAS := 0;
                     V_DTPARC := P_DTCONTAPAG;
                  ELSIF V_IDTIPODTPGTO = 'UEME' THEN
                     V_INDIAS := 1;
                     V_DTPARC := P_DTCONTAPAG;
                  END IF;
               END IF;
            END IF;   
            
       --PARCELAS PARA GERAO DE TIPO DE PAGAMENTO VARIVEL
            FOR C_PRAZOPGTFORN IN
                (SELECT CDFORNECED,
                        TO_NUMBER(NRDIASPGTOFO) AS NRDIASPGTOFO,
                        VRPERCPGTOFO
                   FROM PRAZOPGTFORN
                  WHERE (CDFORNECED = P_CDFORNECED)
                  ORDER BY NRDIASPGTOFO) LOOP
                  
               V_PROXLANBOLPAG := NULL;                  
               V_DTVENCIMENTO := NULL;
               V_INGUARDANRDIAS := NULL;
               
               IF NOT (C_PRAZOPGTFORN.VRPERCPGTOFO = 0) THEN
                  V_VRPARCVENC := (P_VRCONTAPAG * (C_PRAZOPGTFORN.VRPERCPGTOFO / 100));
              --    V_VRPARCAUXI := V_VRPARCAUXI + V_VRPARCVENC;
               END IF;   
                 
               IF C_PRAZOPGTFORN.NRDIASPGTOFO = 0 THEN
                  V_INGUARDANRDIAS := V_INDIAS +1;
               ELSE
                  V_INGUARDANRDIAS := V_INDIAS + C_PRAZOPGTFORN.NRDIASPGTOFO;
               END IF;
                  
               IF NOT (P_DTCONTAPAG IS NULL) THEN
                  IF NOT (V_INGUARDANRDIAS IS NULL) THEN 
                     V_DTVENCIMENTO := P_DTCONTAPAG + V_INGUARDANRDIAS; 
                  ELSE
                     V_DTVENCIMENTO := P_DTCONTAPAG; 
                  END IF; 
               END IF; 
               
               IF V_IDTPPERIODO = 'M' THEN
                  V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIAMES(V_CDFORMPGTO,
                                                               V_DTVENCIMENTO);
               ELSIF V_IDTPPERIODO = 'S' THEN
                  V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANA(V_CDFORMPGTO,
                                                                  V_DTVENCIMENTO);
               ELSE
                  V_DTVENCIMENTO := UTIL_CRIAVENCIMENTO.DIASEMANAMES(V_CDFORMPGTO,
                                                                     V_DTVENCIMENTO);
               END IF;
             --  RETURN V_DTVENCIMENTO;
               
            /* Feriado bancrio   
               IF V_BOCONSFERIBANC THEN
                  CONSISTE_FERI_BANC(P_CDFILIEMIRECE,
                                     V_DTVENCIMENTO,
                                     V_DTVENCIMENTO,
                                     V_IDTIPODTPGT,
                                     P_DTEMISSAO);
               END IF; */
               
               IF ((P_NRSEQVENPAG IS NULL) OR (P_NRSEQVENPAG = '')) THEN
                  V_NRSEQVENPAG := '00';
               ELSE
                  V_NRSEQVENPAG := P_NRSEQVENPAG;
               END IF;  
           
               INSERT INTO BOLETPAGAR
                  (CDFILIAL   , NRLANBOLPAG, CDFORNECED  , CDEMPRESA , VRBOLPAG,
                   VRFINALBPAG, DTVENBOLPAG, IDHABIBPAG  , IDSTATBPAG,
                   IDBPAGREAL , IDSITUCNABP, NRPARCBOLPAG)
               VALUES
                  (P_CDFILIAL  , V_NRLANBOLPAG , P_CDFORNECED, P_CDEMPRESA, V_VRPARCVENC,
                   V_VRPARCVENC, V_DTVENCIMENTO, 'N'         , 'A'        ,
                   'N'         , '00'          , '00');

               -- - ATUALIZA O FLUXO DE CAIXA -------------------------- 
               ATUALIZA_FLUXO_DE_CAIXA(P_CDEMPRESA,  P_CDFILIAL, V_DTVENCIMENTO,
                                               'E', V_CDCLASSFINA, 0, V_VRPARCVENC);                               

               INSERT INTO CONTAPAGAR
                  (CDFILIAL    , NRLANCTONF  , NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR,
                   QTDIASVENPAG, DTORIGVENPAG, VRORIGPAG  , DTATUAVENPAG, VRATUAPAG  ,
                   IDSTATPAG   , DSCONTAPAG  , CDFILIBPAG , NRLANBOLPAG , CDCLASSFINA,
                   CDEMPRESA   , CDFIMOVFLPAG, DTMOVFLUXO , IDMOVFLUXO)
               VALUES
                  (P_CDFILIAL , P_NRLANCTONF  , V_NRSEQVENPAG  , LPAD(V_PARCELA, 2, 0), V_CDTPCTPAGAR,
                   '0'        , V_DTVENCIMENTO, V_VRPARCVENC   , V_DTVENCIMENTO, V_VRPARCVENC ,
                   'A', P_DSCONTAPAG||' - '|| V_DSTPCTPAGAR    , P_CDFILIAL    , V_NRLANBOLPAG, V_CDCLASSFINA,
                   P_CDEMPRESA, P_CDFILIAL    , V_DTVENCIMENTO , 'E');                  
                 
               V_PARCELA := V_PARCELA + 1;
               IF (V_INCOUNT > 1) THEN
                  NOVO_CODIGO('BOLETPAGAR'||P_CDFILIAL, V_PROXLANBOLPAG, 1);
                  V_NRLANBOLPAG := SUBSTR(V_PROXLANBOLPAG, 11,10);             
               END IF;
                     
            END LOOP;
         END IF;   
/* =================================================================================================== */   
      END IF;
   ELSE
      P_GERA_ERRO   := '4';
      UPDATE NOTAFISCAL
      SET VRNOTAFISC = VRNOTAFISC + P_VRCONTAPAG
      WHERE
         CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

      FOR C_CONTAPAG IN
         (SELECT CDFILIAL,     NRLANCTONF,   NRSEQVENPAG,
                 NRPARCELAPAG, CDFILIBPAG,   NRLANBOLPAG,
                 CDEMPRESA,    CDFIMOVFLPAG, DTMOVFLUXO,
                 CDCLASSFINA
          FROM CONTAPAGAR
          WHERE
             CDFILIAL   = P_CDFILIAL AND
             NRLANCTONF = P_NRLANCTONF) LOOP

         ATUALIZA_FLUXO_DE_CAIXA(C_CONTAPAG.CDEMPRESA, C_CONTAPAG.CDFIMOVFLPAG,
                                 C_CONTAPAG.DTMOVFLUXO, 'E', C_CONTAPAG.CDCLASSFINA,
                                 0, P_VRCONTAPAG);

         UPDATE CONTAPAGAR
         SET VRORIGPAG = VRORIGPAG + P_VRCONTAPAG,
             VRATUAPAG = VRATUAPAG + P_VRCONTAPAG
         WHERE
            CDFILIAL     = C_CONTAPAG.CDFILIAL    AND
            NRLANCTONF   = C_CONTAPAG.NRLANCTONF  AND
            NRSEQVENPAG  = C_CONTAPAG.NRSEQVENPAG AND
            NRPARCELAPAG = C_CONTAPAG.NRPARCELAPAG;

         UPDATE BOLETPAGAR
         SET VRBOLPAG    = VRBOLPAG + P_VRCONTAPAG,
             VRFINALBPAG = VRFINALBPAG + P_VRCONTAPAG
         WHERE
            CDFILIAL    = C_CONTAPAG.CDFILIBPAG AND
            NRLANBOLPAG = C_CONTAPAG.NRLANBOLPAG;
            
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_CONTA_COMISSAO','5.05.021'); END;
/
