CREATE OR REPLACE PROCEDURE CALCULA_EMB_SERV
(
   P_CDFILIAL IN VARCHAR2,
   P_CDSERVFILI IN VARCHAR2,
   P_DTCARDAPIO IN DATE,
   P_CDCLIENTE IN VARCHAR2,
   P_CDDESTFILI IN VARCHAR2,
   P_SUBSTITUI_DIST_ATUAL IN VARCHAR2,
   P_RETORNO OUT VARCHAR2
)
IS   
   /*Nmero do cardpio*/
   V_NRCARDAPIO VARCHAR2(10);
   /*Indicador de servio transportado*/
   V_IDSERVTRAN VARCHAR2(1);
   /*Chave da distribuio do cardpio*/
   V_NRDISTCARD NUMBER;
   /*Chave da embalagem da distribuio do cardpio*/
   V_NREMBDISTCARD NUMBER;
   
   /*Para indicar qual das configuraes de embalagem (servio ou ponto de entrega) ser utilizada*/
   V_CONF_A_UTILIZAR INT;
   
   /*Indica que a embalagem  nova e deve ser inserida na tabela DISTEMBCARD*/
   PRIMEIRA_ITERACAO_GRUPO BOOLEAN;
   /*Muda a cada vez que a embalagem trocar*/
   V_NRGRUPO_ATUAL NUMBER;
   
   /*Indica que o prato  representante da embalagem*/
   V_IDPRINCIPAL VARCHAR2(1);
   
   /*Sequencial da novo cdigo*/
   V_SEQUENCIAL VARCHAR2(20);

   /*Nmero de comensais do ponto de entrega*/
   V_QTCOMESTICLI FLOAT;
   
   /*Nmero de comensais do cardpio do servio*/
   V_QTCOMESTICAR FLOAT;
   
   /*Total de comensais do dia*/
   V_QTTOTCOMENS FLOAT;
      
   
   /*=========================*/
   /*===== CURSOR DOS PRATOS =====*/
   /*=========================*/
   
   /*CURSOR DOS PRATOS*/   
   V_NRSEQPRATCAR NUMBER(3);
   V_CDFILAUXPRAT VARCHAR2(4);
   V_CDPRATO VARCHAR2(10);
   V_VRPECONSCARD FLOAT;   
   V_NRGRUPO NUMBER;
   V_CDCNFDISTEMBSERV VARCHAR2(5);
   V_IDPROPOSITO VARCHAR2(1);
   V_CDCONTAINER VARCHAR2(5);
   V_VRQTDEPRATEMB FLOAT;
   V_QTPORPESSOA FLOAT;
   V_QTTOTEXTRA FLOAT;
   
   /*Comensais do prato*/
   V_COMENSAIS FLOAT;
   /*Quantidade total do prato*/
   V_QTPRATO FLOAT;
   
   /*Quantidade de container*/
   V_QTCONTAINER FLOAT;
   
   CURSOR C_PRATOS
   IS
      SELECT C.NRSEQPRATCAR, C.CDFILAUXPRAT, C.CDPRATO, C.VRPECONSCARD,
           CNF.NRGRUPO, CNF.CDCNFDISTEMBSERV, CNF.IDPROPOSITO, CNF.CDCONTAINER,
           R.VRQTDEPRATEMB, NVL(QTPORPESSOA, 0) QTPORPESSOA, NVL(QTTOTEXTRA, 0) QTTOTEXTRA
      FROM COMPCARD C
           /*Configurao de embalagem para o tipo de prato*/
           LEFT JOIN 
           (
           SELECT CNF.NRSEQCNFCARD, CNF.NRGRUPO, CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.IDPROPOSITO
           FROM CNFDISTEMBSERV CNF
                LEFT JOIN CONTAINER C ON C.CDCONTAINER = CNF.CDCONTAINER
           WHERE CDFILIAL = P_CDFILIAL
             AND CDSERVFILI = P_CDSERVFILI
             AND CDCLIENTE IS NULL
             AND V_CONF_A_UTILIZAR = 1
           UNION
           SELECT CNF.NRSEQCNFCARD, CNF.NRGRUPO, CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.IDPROPOSITO
           FROM CNFDISTEMBSERV CNF
                LEFT JOIN CONTAINER C ON C.CDCONTAINER = CNF.CDCONTAINER
           WHERE CDFILIAL = P_CDFILIAL
             AND CDSERVFILI = P_CDSERVFILI
             AND CDCLIENTE = P_CDCLIENTE
             AND CDDESTFILI = P_CDDESTFILI
             AND V_CONF_A_UTILIZAR = 2
          ) CNF ON CNF.NRSEQCNFCARD = C.NRSEQPRATCAR
          /*Relao entre embalagem selecionada e prato*/
          LEFT JOIN RELPRATEMB R ON R.CDFILAUXPRAT = C.CDFILAUXPRAT AND
                                    R.CDPRATO = C.CDPRATO AND
                                    R.CDCONTAINER = CNF.CDCONTAINER
         /*Peso unitrio e quantidade de amostra (extra) do prato*/
          LEFT JOIN
          (
            SELECT CDFILAUXPRAT, CDPRATO, QTPADRAOPRAT AS QTPORPESSOA, QTAMOSTRPADR AS QTTOTEXTRA, 'P' AS RECE_UTIL
            FROM PRATPADR            

            UNION 

            SELECT CDFILAUXPRAT, CDPRATO, QTPADRAOFILI AS QTPORPESSOA, QTAMOSTRFILI AS QTTOTEXTRA, 'F' AS RECE_UTIL
            FROM PRATFILI
            WHERE CDFILIAL = P_CDFILIAL
            
            UNION 

            SELECT CDFILAUXPRAT, CDPRATO, QTPADRAOSERV AS QTPORPESSOA, QTAMOSTRSERV AS QTTOTEXTRA, 'S' AS RECE_UTIL
            FROM PRATSERV
            WHERE CDFILIAL = P_CDFILIAL AND
                        CDSERVFILI = P_CDSERVFILI
            
          ) P ON P.CDFILAUXPRAT = C.CDFILAUXPRAT AND
                    P.CDPRATO = C.CDPRATO AND
                    RECEITA_UTILIZADA(C.CDPRATO, C.CDFILAUXPRAT, P_CDFILIAL, P_CDSERVFILI) = P.RECE_UTIL
                    
      WHERE C.CDFILIAL = P_CDFILIAL AND
            C.NRCARDAPIO = V_NRCARDAPIO
      ORDER BY NRGRUPO;
      
BEGIN
   /*=======================================*/
   /*===== VERIFICAO DO SERVIO E DO CARDPIO =====*/
   /*=======================================*/
   BEGIN
      SELECT C.NRCARDAPIO, S.IDSERVTRAN, D.NRDISTCARD, NVL(CL.QTCOMESTICLI, 0), C.QTCOMESTICAR
        INTO V_NRCARDAPIO, V_IDSERVTRAN, V_NRDISTCARD, V_QTCOMESTICLI, V_QTCOMESTICAR
      FROM CARDADIA C
         INNER JOIN SERVICO S ON S.CDFILIAL = C.CDFILIAL AND
                                 S.CDSERVFILI = C.CDSERVFILI
         LEFT JOIN CARDACLI CL ON CL.CDFILIAL = C.CDFILIAL AND
                                   CL.NRCARDAPIO = C.NRCARDAPIO AND
                                   CL.CDCLIENTE = P_CDCLIENTE AND
                                   CL.CDDESTFILI = P_CDDESTFILI
         LEFT JOIN DISTCARD D ON D.CDFILIAL = C.CDFILIAL AND
                                 D.NRCARDAPIO = C.NRCARDAPIO AND
                                 ((P_CDCLIENTE IS NULL) OR 
                                  (D.CDCLIENTE = P_CDCLIENTE AND D.CDDESTFILI = P_CDDESTFILI))
      WHERE C.DTCARDAPIO = P_DTCARDAPIO
        AND C.CDFILIAL = P_CDFILIAL
        AND C.CDSERVFILI = P_CDSERVFILI;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         P_RETORNO := 'ERRO_N_EXIST_CARD';
         RETURN;
   END;
   
   IF V_IDSERVTRAN <> 'S' THEN      
      P_RETORNO := 'ERRO_SERV_N_TRANS';
      RETURN;
   END IF;
   
   IF P_CDCLIENTE IS NOT NULL AND (V_QTCOMESTICLI <= 0) THEN
      P_RETORNO := 'ERRO_COMESTICLI_ZERO';
      RETURN;
   ELSIF (V_QTCOMESTICAR <= 0) THEN
      P_RETORNO := 'ERRO_COMESTICAR_ZERO';
      RETURN;
   END IF;
   
   IF P_CDCLIENTE IS NOT NULL THEN
      V_QTTOTCOMENS := V_QTCOMESTICLI;
   ELSE
      V_QTTOTCOMENS := V_QTCOMESTICAR;
   END IF;
   
   /*============================*/
   /*===== DISTRIBUICAO EXISTENTE =====*/
   /*============================*/   
   
   IF V_NRDISTCARD IS NOT NULL THEN
      IF P_SUBSTITUI_DIST_ATUAL = 'S' THEN
         /*Apaga a distribuio existente para o cardpio*/
         DELETE FROM ITEMBDISTCARD
         WHERE NRDISTCARD = V_NRDISTCARD;
         
         DELETE FROM EMBDISTCARD
         WHERE NRDISTCARD = V_NRDISTCARD;
         
         DELETE FROM CNFDISTCARD
         WHERE NRDISTCARD = V_NRDISTCARD;
         
         DELETE FROM DISTCARD
         WHERE NRDISTCARD = V_NRDISTCARD;
      ELSE
         /*Consiste se houve alterao do cardpio que invalide a distribuio : */
         /*   Mudana de prato, excluso de uma coluna ou incluso de uma coluna na elaborao*/
         BEGIN
            SELECT NVL(C.NRSEQPRATCAR, CNF.NRSEQPRATCAR)
              INTO V_NRSEQPRATCAR
              FROM COMPCARD C
                  FULL OUTER JOIN CNFDISTCARD CNF
                     ON CNF.NRSEQPRATCAR = C.NRSEQPRATCAR AND
                        CNF.NRDISTCARD = V_NRDISTCARD
             WHERE C.CDFILIAL = P_CDFILIAL
               AND C.NRCARDAPIO = V_NRCARDAPIO
               AND ((C.CDPRATO <> CNF.CDPRATO) OR (C.CDFILAUXPRAT <> CNF.CDFILAUXPRAT) OR (CNF.NRDISTCARD IS NULL) OR (C.NRSEQPRATCAR IS NULL));
               
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRSEQPRATCAR := NULL;
         END;
         
         /*Indica que houve mudana nos pratos do cardpio*/
         IF V_NRSEQPRATCAR IS NOT NULL THEN
            P_RETORNO := 'ERRO_PRAT_CARD_ALT';
            RETURN;
         ELSE
            P_RETORNO := TO_CHAR(V_NRDISTCARD);
            RETURN;
         END IF;
      END IF;
   END IF;

   /*=============================================================*/
   /*DETERMINA QUAL CONFIGURAO UTILIZAR : SE A DO SERVIO OU A DO PONTO DE ENTREGA*/
   /*=============================================================*/
   BEGIN
      SELECT MAX(CONF_A_UTILIZAR)
         INTO V_CONF_A_UTILIZAR
      FROM
      (
        /*VERIFICA SE H CONFIGURAO DE EMBALAGENS PARA O SERVIO*/
        SELECT 1 AS CONF_A_UTILIZAR
        FROM DUAL
        WHERE EXISTS
        (
          SELECT 1
          FROM CNFDISTEMBSERV
          WHERE CDFILIAL = P_CDFILIAL 
          AND CDSERVFILI = P_CDSERVFILI
          AND CDCLIENTE IS NULL 
        )
        
        UNION
        /*VERIFICA SE H CONFIGURAO DE EMBALAGENS PARA O PONTO DE ENTREGA*/
        SELECT 2 AS CONF_A_UTILIZAR
        FROM DUAL
        WHERE EXISTS
        (
          SELECT 1
          FROM CNFDISTEMBSERV
          WHERE CDFILIAL = P_CDFILIAL 
            AND CDSERVFILI = P_CDSERVFILI
            AND CDCLIENTE = P_CDCLIENTE
            AND CDDESTFILI = P_CDDESTFILI
        )
      ) S;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         /*Indica que no h configurao a ser utilizada*/
         V_CONF_A_UTILIZAR := 0;
   END;
   
   /*Inclui distribuio do cardapio*/
   /*Busca novo sequencial*/               
   NOVO_CODIGO_SC('DISTCARD',V_SEQUENCIAL);
   V_NRDISTCARD := TO_NUMBER(V_SEQUENCIAL);
   
   INSERT INTO DISTCARD
   (NRDISTCARD, CDFILIAL,NRCARDAPIO, CDCLIENTE, CDDESTFILI, QTCOMENSAIS)
   VALUES
   (V_NRDISTCARD, P_CDFILIAL, V_NRCARDAPIO, P_CDCLIENTE, P_CDDESTFILI, V_QTTOTCOMENS);


   /*USADA PARA INDICAR QUEBRA DE PROCESSAMENTO DE EMBALAGENS*/
   V_NRGRUPO_ATUAL := -1; 
   
   /*=======================================*/
   /*PERCORRE OS PRATOS DO SERVIO PARA O DIA INFORMADO*/      
   /*=======================================*/
   OPEN C_PRATOS;
   
   LOOP
   
      FETCH C_PRATOS
      INTO V_NRSEQPRATCAR, V_CDFILAUXPRAT, V_CDPRATO, V_VRPECONSCARD,            
               V_NRGRUPO, V_CDCNFDISTEMBSERV, V_IDPROPOSITO, V_CDCONTAINER,                   
               V_VRQTDEPRATEMB, V_QTPORPESSOA, V_QTTOTEXTRA;
      EXIT WHEN C_PRATOS%NOTFOUND;
      
      V_COMENSAIS := ROUND((V_VRPECONSCARD/100) * V_QTTOTCOMENS, 5);         
      V_QTPRATO := ROUND(V_COMENSAIS * V_QTPORPESSOA, 5);
      
      /*Insere a configurao do cardpio considerada na distribuio, bem como outras grandezas envolvidas*/
      INSERT INTO CNFDISTCARD
      (NRDISTCARD, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, QTTOTCOMENSAIS, 
       QTTOTPRATO, QTPORPESSOA, QTTOTEXTRA, IDCADAUTO)
      VALUES
      (V_NRDISTCARD, V_NRSEQPRATCAR, V_CDFILAUXPRAT, V_CDPRATO, V_COMENSAIS, 
       V_QTPRATO, V_QTPORPESSOA, V_QTTOTEXTRA, 'S');
      
      /*VERIFICA QUEBRA DE GRUPO (NOVA EMBALAGEM SENDO PROCESSADA)*/
      IF V_NRGRUPO_ATUAL <> V_NRGRUPO THEN
         V_NRGRUPO_ATUAL := V_NRGRUPO;
         /*INDICA MOMENTO DE INSERO DAS EMBALAGENS*/
         PRIMEIRA_ITERACAO_GRUPO := TRUE;
      END IF;
      
      /*===========================*/
      /*===== EMBALAGENS COLETIVAS =====*/
      /*===========================*/
      /*Se a embalagem e o prato no foram relacionados, no faz a distribuio deste na embalagem*/
      IF (V_IDPROPOSITO = 'C') AND (V_VRQTDEPRATEMB IS NOT NULL) THEN            
         IF V_QTPORPESSOA > 0 THEN
            IF PRIMEIRA_ITERACAO_GRUPO THEN
               /*Quantidade de containers : completos + incompleto*/
               V_QTCONTAINER := TRUNC(V_QTPRATO/V_VRQTDEPRATEMB);
               IF MOD(V_QTPRATO, V_VRQTDEPRATEMB) <> 0 THEN
                  V_QTCONTAINER := V_QTCONTAINER + 1;
               END IF;
               
               /*Busca novo sequencial*/               
               NOVO_CODIGO_SC('EMBDISTCARD',V_SEQUENCIAL);
               V_NREMBDISTCARD := TO_NUMBER(V_SEQUENCIAL);
               
               /*Insere embalagem na distribuio do cardpio*/
               INSERT INTO EMBDISTCARD
               (NRDISTCARD, NREMBDISTCARD, CDCONTAINER, QTCONTAINER, IDCADAUTO)
               VALUES
               (V_NRDISTCARD, V_NREMBDISTCARD, V_CDCONTAINER, V_QTCONTAINER, 'S');
               
            END IF;
            
            /*Insere o prato na embalagem na distribuio*/
            INSERT INTO ITEMBDISTCARD
            (NRDISTCARD, NRSEQPRATCAR, NREMBDISTCARD, 
             QTCOMENSAIS, QTPRATO, QTEXTRA, IDCADAUTO, IDPRINCIPAL)
            VALUES
            (V_NRDISTCARD, V_NRSEQPRATCAR, V_NREMBDISTCARD, 
             V_COMENSAIS, V_QTPRATO, V_QTTOTEXTRA, 'S', 'S');
         END IF;
      /*============================*/
      /*===== EMBALAGENS INDIVIDUAIS =====*/
      /*============================*/
      
      ELSIF (V_IDPROPOSITO = 'I') THEN
         IF PRIMEIRA_ITERACAO_GRUPO THEN             
            V_IDPRINCIPAL := 'S';
            /*Busca novo sequencial*/
            NOVO_CODIGO_SC('EMBDISTCARD',V_SEQUENCIAL);
            V_NREMBDISTCARD := TO_NUMBER(V_SEQUENCIAL);
            
            /*Insere embalagem na distribuio do cardpio*/
            INSERT INTO EMBDISTCARD
            (NRDISTCARD, NREMBDISTCARD, CDCONTAINER, QTCONTAINER, IDCADAUTO)
            VALUES
            (V_NRDISTCARD, V_NREMBDISTCARD, V_CDCONTAINER, V_QTTOTCOMENS, 'S');
         END IF;
         
         /*Insere o prato na embalagem na distribuio*/
         INSERT INTO ITEMBDISTCARD
         (NRDISTCARD, NRSEQPRATCAR, NREMBDISTCARD, 
          QTCOMENSAIS, QTPRATO, QTEXTRA, IDCADAUTO, IDPRINCIPAL)
         VALUES
         (V_NRDISTCARD, V_NRSEQPRATCAR, V_NREMBDISTCARD, 
          V_COMENSAIS, V_QTPRATO, V_QTTOTEXTRA, 'S', V_IDPRINCIPAL);
         V_IDPRINCIPAL := 'N';
      
      /*==============================================*/
      /*===== DISTRIBUIO AUTOMTICA ======================*/
      /*Para todos os que no foram contemplados pelos passos acima :          */         
      /*- Pratos  que no possuem relao explicitada com a embalagem           */
      /*- Pratos cujo tipo de prato no pertence  conf. original do servio         */
      /*- Pratos cuja distribuio foi definida como automtica na tela de servio*/
      /*==============================================*/
      
      ELSE            
         IF V_CDCNFDISTEMBSERV = 'DISTR' THEN               
            DIST_AUTO_PRAT(V_NRDISTCARD, V_NRSEQPRATCAR,'DISTR');
         ELSIF V_CDCNFDISTEMBSERV = 'DIST' THEN
            DIST_AUTO_PRAT(V_NRDISTCARD, V_NRSEQPRATCAR, 'DIST');
         END IF;
      END IF;
      
      /*Somente  verdadeiro para a primeira iterao de uma embalagem da configurao*/
      PRIMEIRA_ITERACAO_GRUPO := FALSE;
   
   END LOOP;
   
   CLOSE C_PRATOS;
   
   
   /*ATUALIZA SITUAO DA DISTRIBUIO QUANTO  SUA COMPLETUDE*/
   BEGIN
      SELECT MAX(C.NRSEQPRATCAR)
             INTO V_NRSEQPRATCAR
      FROM CNFDISTCARD C
           LEFT JOIN
          (
           SELECT NRDISTCARD, NRSEQPRATCAR, SUM(QTCOMENSAIS) AS QTCOMENSAIS,
                  SUM(QTPRATO) AS QTPRATO, SUM(QTEXTRA) AS QTEXTRA
             FROM ITEMBDISTCARD
             WHERE NRDISTCARD = V_NRDISTCARD
           GROUP BY NRDISTCARD, NRSEQPRATCAR
          ) U ON U.NRSEQPRATCAR = C.NRSEQPRATCAR
      WHERE C.NRDISTCARD = V_NRDISTCARD AND
            (C.QTTOTCOMENSAIS - NVL(U.QTCOMENSAIS, 0) > 0 OR
             C.QTTOTPRATO - NVL(U.QTPRATO, 0) > 0 OR
             C.QTTOTEXTRA - NVL(U.QTEXTRA, 0) > 0 );

   EXCEPTION
      WHEN NO_DATA_FOUND THEN
      
         UPDATE DISTCARD
         SET IDSITUACAO = 'C'
         WHERE NRDISTCARD = V_NRDISTCARD;
      
   END;
   
   IF V_NRSEQPRATCAR IS NOT NULL THEN
      UPDATE DISTCARD
         SET IDSITUACAO = 'I'
         WHERE NRDISTCARD = V_NRDISTCARD;
   ELSE
      UPDATE DISTCARD
         SET IDSITUACAO = 'C'
         WHERE NRDISTCARD = V_NRDISTCARD;
   END IF;   
   
   P_RETORNO := TO_CHAR(V_NRDISTCARD);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_EMB_SERV','6.05.000'); END;
/